# pyright: reportUnusedImport=false
import struct
from typing import Optional, Self, Sequence
from .. import abcs
from ..core import Request, serialize_bytes_to
_bytes = bytes | bytearray | memoryview
def get_lang_pack(*, lang_pack: str, lang_code: str) -> Request[abcs.LangPackDifference]:
    _buffer = bytearray(b'\n3\xf2\xf2')
    serialize_bytes_to(_buffer, lang_pack.encode('utf-8'))
    serialize_bytes_to(_buffer, lang_code.encode('utf-8'))
    return Request(b'' + _buffer)
def get_strings(*, lang_pack: str, lang_code: str, keys: Sequence[str]) -> Request[Sequence[abcs.LangPackString]]:
    _buffer = bytearray(b'\x038\xea\xef')
    serialize_bytes_to(_buffer, lang_pack.encode('utf-8'))
    serialize_bytes_to(_buffer, lang_code.encode('utf-8'))
    _buffer += struct.pack('<ii', 0x1cb5c415, len(keys))
    for _t0 in keys:
      serialize_bytes_to(_buffer, _t0.encode('utf-8'))
    return Request(b'' + _buffer)
def get_difference(*, lang_pack: str, lang_code: str, from_version: int) -> Request[abcs.LangPackDifference]:
    _buffer = bytearray(b'\xa5J\x98\xcd')
    serialize_bytes_to(_buffer, lang_pack.encode('utf-8'))
    serialize_bytes_to(_buffer, lang_code.encode('utf-8'))
    _buffer += struct.pack('<i', from_version)
    return Request(b'' + _buffer)
def get_languages(*, lang_pack: str) -> Request[Sequence[abcs.LangPackLanguage]]:
    _buffer = bytearray(b'\x8f\x97\xc6B')
    serialize_bytes_to(_buffer, lang_pack.encode('utf-8'))
    return Request(b'' + _buffer)
def get_language(*, lang_pack: str, lang_code: str) -> Request[abcs.LangPackLanguage]:
    _buffer = bytearray(b'\x02eYj')
    serialize_bytes_to(_buffer, lang_pack.encode('utf-8'))
    serialize_bytes_to(_buffer, lang_code.encode('utf-8'))
    return Request(b'' + _buffer)
